/*-------------------------------------------------------------------*/
/* mdstring.c - computes md5 checksum of a string                    */
/*                                                                   */
/*                                                                   */
/* (c) Copyright by Jochen Bauer <jtb@theo2.physik.uni-stuttgart.de> */
/*                                                                   */
/*   !!This file is intended for educational purposes only!!         */
/* You may freely spread and modify it, provided that this copyright */
/* statement is retained in any copy or modification of this file.   */
/*                                                                   */
/*                                                                   */  
/* You may only use this file or any modification of it for          */   
/* educational purposes. You are not allowed to use it to place      */
/* backdoors into systems without the explicit permission of the     */
/* legitimate root.                                                  */
/*                                                                   */ 
/* DISCLAIMER: I am NOT responsible for what YOU do with this file.  */
/*                                                                   */
/* This file uses the "RSA Data Security, Inc. MD5 Message-Digest    */
/* Algorithm".                                                       */
/*-------------------------------------------------------------------*/

/*I made a separate file for this function in order to make the
  md5 parts completely separable from my work.*/

#include "global.h"
#include "md5.h"
#include "defs.h"

char *checksum(char *string,char *buffer) /*compute the md5 checksum of string*/
{                                          /*and stores it into buffer; buffer must*/
  char high,low,i;                         /*be >=32 bytes long*/
  MD5_CTX context;
  unsigned char digest[HASHLENGTH];
  unsigned int length=strlen(string);

  MD5Init(&context);
  MD5Update(&context,string,length);
  MD5Final(digest,&context);
  
  for(i=0;i<16;i++)
   {
    high=digest[i]/16;
    switch(high)
     {
     case 0 : buffer[2*i]='0';break;
     case 1 : buffer[2*i]='1';break;
     case 2 : buffer[2*i]='2';break;
     case 3 : buffer[2*i]='3';break;
     case 4 : buffer[2*i]='4';break;
     case 5 : buffer[2*i]='5';break;
     case 6 : buffer[2*i]='6';break;
     case 7 : buffer[2*i]='7';break;
     case 8 : buffer[2*i]='8';break;
     case 9 : buffer[2*i]='9';break;
     case 10 : buffer[2*i]='a';break;
     case 11 : buffer[2*i]='b';break;
     case 12 : buffer[2*i]='c';break;
     case 13 : buffer[2*i]='d';break;
     case 14 : buffer[2*i]='e';break;
     case 15 : buffer[2*i]='f';break;
     default : buffer[2*i]='X';break;
     }
    low=digest[i]%16;
    switch(low)
     {
     case 0 : buffer[2*i+1]='0';break;
     case 1 : buffer[2*i+1]='1';break;
     case 2 : buffer[2*i+1]='2';break;
     case 3 : buffer[2*i+1]='3';break;
     case 4 : buffer[2*i+1]='4';break;
     case 5 : buffer[2*i+1]='5';break;
     case 6 : buffer[2*i+1]='6';break;
     case 7 : buffer[2*i+1]='7';break;
     case 8 : buffer[2*i+1]='8';break;
     case 9 : buffer[2*i+1]='9';break;
     case 10 : buffer[2*i+1]='a';break;
     case 11 : buffer[2*i+1]='b';break;
     case 12 : buffer[2*i+1]='c';break;
     case 13 : buffer[2*i+1]='d';break;
     case 14 : buffer[2*i+1]='e';break;
     case 15 : buffer[2*i+1]='f';break;
     default : buffer[2*i+1]='X';break;
     }
   }
  buffer[2*HASHLENGTH]=0;
  return(buffer);
}
